#ifndef _SETJMP_H
#define _SETJMP_H

#ifdef __cplusplus
extern "C" {
#endif

#ifdef ixemul

#ifdef __PPC__
#define _JBLEN  (7+19+2*18+14+3*6) /* onstack, sigmask, r1, r2, flags, lr, cr, r13-r31, f14-f31, pc, *a7, d2-d7, a2-a7, fp2-fp7 */
#else
#define _JBLEN  17  /* onstack, sigmask, sp, a5, flags, pc, 0, d2-d7/a2-a4/a6 */
#endif

typedef int sigjmp_buf[_JBLEN + 1];
typedef int jmp_buf[_JBLEN];

#else

#define _JBLEN 59 /* r1,r13-r31,cr,lr,f14-f31,r2 */

typedef int jmp_buf[_JBLEN] __attribute__((aligned(8)));
typedef int sigjmp_buf[_JBLEN+2] __attribute__((aligned(8)));

#endif

int setjmp(jmp_buf);
void longjmp(jmp_buf, int) __attribute__((noreturn));

int sigsetjmp(sigjmp_buf, int);
void siglongjmp(sigjmp_buf, int) __attribute__((noreturn));

#if defined(ixemul) && !defined(_ANSI_SOURCE) && !defined(_POSIX_SOURCE)
int     _setjmp(jmp_buf);
void    volatile _longjmp(jmp_buf, int);
void    longjmperror(void);
#endif /* neither ANSI nor POSIX */

#ifdef __cplusplus
}
#endif

#endif

